package it.unibas.acibase.persistenza;

import java.sql.*;
import java.util.*;
import it.unibas.acibase.modello.*;
import it.unibas.utilita.Logger;

public class DAOAutomobile {
    
    public static Automobile doSelectTarga(String targa) throws DAOException {
        Automobile automobile = null;
        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        DataSource dataSource = DataSource.getInstance();
        try {
            connection = dataSource.getConnection();
            statement = connection.createStatement();
            String query = "select * from automobili where targa = '" + targa + "'";
            Logger.logFine("DAOAutomobile", "doSelectTarga", query);
            resultSet = statement.executeQuery(query);
            if (resultSet.next()){
                automobile = new Automobile();
                automobile.setTarga(resultSet.getString("targa"));
                automobile.setModello(resultSet.getString("modello"));
                automobile.setCilindrata(resultSet.getInt("cilindrata"));
                automobile.setCodiceFiscaleProprietario(resultSet.getString("proprietario"));
            }
        } catch (SQLException sqle) {
            throw new DAOException(sqle);
        } finally {
            dataSource.close(resultSet);
            dataSource.close(statement);
            dataSource.close(connection);
        }
        return automobile;
    }
    
    public static void doInsert(Automobile automobile) throws DAOException {
        DataSource dataSource = DataSource.getInstance();
        Connection connection = null;
        Statement statement = null;
        try {
            connection = dataSource.getConnection();
            statement = connection.createStatement();
            String query =
                    "insert into automobili values ('" + automobile.getTarga() + "', " +
                    "'" + automobile.getModello() + "', " +
                    "" + automobile.getCilindrata() + ", " +
                    "'" + automobile.getProprietario().getCodiceFiscale() + "')";
            Logger.logFine("DAOAutomobile", "doInsert", query);
            statement.executeUpdate(query);
        } catch (SQLException sqle) {
            throw new DAOException(sqle);
        } finally {
            dataSource.close(statement);
            dataSource.close(connection);
        }
    }
    
    public static void doUpdate(Automobile automobile) throws DAOException {
        DataSource dataSource = DataSource.getInstance();
        Connection connection = null;
        Statement statement = null;
        try {
            connection = dataSource.getConnection();
            statement = connection.createStatement();
            String query =
                    "update automobili set " +
                    "modello = '" + automobile.getModello() + "'," +
                    "cilindrata = " + automobile.getCilindrata() + "," +
                    "proprietario = '" + automobile.getProprietario().getCodiceFiscale() + "'" +
                    "where targa = '" + automobile.getTarga() + "'";
            Logger.logFine("DAOAutomobile", "doUpdate", query);
            statement.executeUpdate(query);
        } catch (SQLException sqle) {
            throw new DAOException(sqle);
        } finally {
            dataSource.close(statement);
            dataSource.close(connection);
        }
    }
    
    public static void doDelete(Automobile automobile) throws DAOException {
        DataSource dataSource = DataSource.getInstance();
        Connection connection = null;
        Statement statement = null;
        try {
            connection = dataSource.getConnection();
            statement = connection.createStatement();
            String query = "delete from automobili " +
                    "where targa = '" + automobile.getTarga() + "'";
            Logger.logFine("DAOAutomobile", "doDelete", query);
            statement.executeUpdate(query);
        } catch (SQLException sqle) {
            throw new DAOException(sqle);
        } finally {
            dataSource.close(statement);
            dataSource.close(connection);
        }
    }
    
    public static void caricaProprietario(Automobile automobile) throws DAOException {
        Proprietario proprietario = DAOProprietario.doSelectCodiceFiscale(automobile.getCodiceFiscaleProprietario());
        automobile.setProprietario(proprietario);
    }
    
    public static Collection doSelectElencoProprietariEAutomobili() throws DAOException{
        DataSource dataSource = DataSource.getInstance();
        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        HashMap elenco = new HashMap();
        try {
            connection = dataSource.getConnection();
            statement = connection.createStatement();
            String query = "select * " +
                    "from proprietari left join automobili " +
                    "on proprietari.codiceFiscale = automobili.proprietario";
            resultSet = statement.executeQuery(query);
            while (resultSet.next()){
                String codiceFiscale = resultSet.getString("codiceFiscale");
                Proprietario proprietario = (Proprietario)elenco.get(codiceFiscale);
                if (proprietario == null){
                    proprietario = new Proprietario();
                    proprietario.setCodiceFiscale(codiceFiscale);
                    proprietario.setNome(resultSet.getString("nome"));
                    proprietario.setCittaDiResidenza(resultSet.getString("cittaDiResidenza"));
                    proprietario.setAnnoPatente(resultSet.getInt("annoPatente"));
                    elenco.put(codiceFiscale, proprietario);
                }
                String targa = resultSet.getString("targa");
                if (targa != null) {
                    Automobile automobile = new Automobile();
                    automobile.setTarga(resultSet.getString("targa"));
                    automobile.setModello(resultSet.getString("modello"));
                    automobile.setCilindrata(resultSet.getInt("cilindrata"));
                    automobile.setProprietario(proprietario);
                    proprietario.aggiungiAutomobile(automobile);
                }
            }
        } catch (SQLException sqle) {
            throw new DAOException(sqle);
        } finally {
            dataSource.close(resultSet);
            dataSource.close(statement);
            dataSource.close(connection);
        }
        return elenco.values();
    }
    
}



