package it.unibas.acibase.persistenza;

import it.unibas.acibase.modello.Automobile;
import it.unibas.acibase.modello.Proprietario;
import it.unibas.utilita.Logger;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

public class DAOProprietario {
    
    public static Proprietario doSelectCodiceFiscale(String codiceFiscale) throws DAOException{
        DataSource dataSource = DataSource.getInstance();
        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        Proprietario proprietario = null;
        try {
            connection = dataSource.getConnection();
            statement = connection.createStatement();
            String query = "select * from proprietari "+
                    "where codicefiscale = '" + codiceFiscale + "'";
            Logger.logFine("DAOProprietario", "doSelectCodiceFiscale", query);
            resultSet = statement.executeQuery(query);
            if (resultSet.next()){
                proprietario = new Proprietario();
                proprietario.setCodiceFiscale(resultSet.getString("codicefiscale"));
                proprietario.setNome(resultSet.getString("nome"));
                proprietario.setCittaDiResidenza(resultSet.getString("cittadiresidenza"));
                proprietario.setAnnoPatente(resultSet.getInt("annoPatente"));
            }
        } catch (SQLException sqle) {
            throw new DAOException("doSelectCodiceFiscale: " + sqle);
        } finally {
            dataSource.close(resultSet);
            dataSource.close(statement);
            dataSource.close(connection);
        }
        return proprietario;
    }
    
    public static List doSelectNome(String nome) throws DAOException{
        DataSource dataSource = DataSource.getInstance();
        Connection connection = null;
        List listaProprietari = new ArrayList();
        Statement statement = null;
        ResultSet resultSet = null;
        try {
            connection = dataSource.getConnection();
            statement = connection.createStatement();
            String query = "select * from proprietari where nome = '" + nome + "'";
            Logger.logFine("DAOProprietario", "doSelectNome", query);
            resultSet = statement.executeQuery(query);
            while (resultSet.next()){
                Proprietario proprietario = new Proprietario();
                proprietario.setCodiceFiscale(resultSet.getString("codicefiscale"));
                proprietario.setNome(resultSet.getString("nome"));
                proprietario.setCittaDiResidenza(resultSet.getString("cittadiresidenza"));
                proprietario.setAnnoPatente(resultSet.getInt("annopatente"));
                listaProprietari.add(proprietario);
            }
        } catch (SQLException sqle) {
            throw new DAOException("doSelectNome: " + sqle);
        } finally {
            dataSource.close(resultSet);
            dataSource.close(statement);
            dataSource.close(connection);
        }
        return listaProprietari;
    }
    
    public static void doInsert(Proprietario proprietario) throws DAOException {
        DataSource dataSource = DataSource.getInstance();
        Connection connection = null;
        Statement statement = null;
        try {
            connection = dataSource.getConnection();
            statement = connection.createStatement();
            String query = "insert into proprietari values (" +
                    "'" + proprietario.getCodiceFiscale() + "'," +
                    "'" + proprietario.getNome() + "'," +
                    "'" + proprietario.getCittaDiResidenza() + "'," +
                    "" + proprietario.getAnnoPatente() + ")";
            Logger.logFine("DAOProprietario", "doInsert", query);
            statement.executeUpdate(query);
        } catch (SQLException sqle) {
            throw new DAOException("doInsert: " + sqle);
        } finally {
            dataSource.close(statement);
            dataSource.close(connection);
        }
    }
    
    public static void doUpdate(Proprietario proprietario) throws DAOException {
        DataSource dataSource = DataSource.getInstance();
        Connection connection = null;
        Statement statement = null;
        try {
            connection = dataSource.getConnection();
            statement = connection.createStatement();
            String query =
                    "update proprietari set " +
                    "nome = '" + proprietario.getNome() + "'," +
                    "cittadiresidenza = '" + proprietario.getCittaDiResidenza() + "'," +
                    "annopatente = " + proprietario.getAnnoPatente() + " " +
                    "where codicefiscale = '" + proprietario.getCodiceFiscale() + "'";
            Logger.logFine("DAOProprietario", "doUpdate", query);
            statement.executeUpdate(query);
        } catch (SQLException sqle) {
            throw new DAOException("doUpdate: " + sqle);
        } finally {
            dataSource.close(statement);
            dataSource.close(connection);
        }
    }
    
    public static void doDelete(Proprietario proprietario) throws DAOException {
        DataSource dataSource = DataSource.getInstance();
        Connection connection = null;
        Statement statement = null;
        try {
            connection = dataSource.getConnection();
            statement = connection.createStatement();
            String query = "delete from proprietari " +
                    "where codicefiscale = '" + proprietario.getCodiceFiscale() + "'";
            Logger.logFine("DAOProprietario", "doDelete", query);
            statement.executeUpdate(query);
        } catch (SQLException sqle) {
            throw new DAOException("doDelete: " + sqle);
        } finally {
            dataSource.close(statement);
            dataSource.close(connection);
        }
    }
    
    public static void caricaAutomobili(Proprietario proprietario) throws DAOException{
        DataSource dataSource = DataSource.getInstance();
        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        try {
            connection = dataSource.getConnection();
            statement = connection.createStatement();
            String query = "select automobili.* " +
                    "from automobili " +
                    "where automobili.proprietario = '" + proprietario.getCodiceFiscale() + "'";
            Logger.logFine("DAOProprietario", "caricaAutomobili", query);
            resultSet = statement.executeQuery(query);
            proprietario.svuotaAutomobili();
            while (resultSet.next()){
                Automobile automobile = new Automobile();
                automobile.setTarga(resultSet.getString("targa"));
                automobile.setModello(resultSet.getString("modello"));
                automobile.setCilindrata(resultSet.getInt("cilindrata"));
                automobile.setProprietario(proprietario);
                proprietario.aggiungiAutomobile(automobile);
            }
        } catch (SQLException sqle) {
            throw new DAOException("caricaAutomobili: " + sqle);
        } finally {
            dataSource.close(resultSet);
            dataSource.close(statement);
            dataSource.close(connection);
        }
    }
    
}



