package it.unibas.acibase.persistenza;

import java.sql.Connection;
import java.sql.Driver;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class DataSource {

    static {
        try {
            // per utilizzare Access
            //Driver driver = new sun.jdbc.odbc.JdbcOdbcDriver();
            // per utilizzare PostgreSQL
            Driver driver = new org.postgresql.Driver();
            DriverManager.registerDriver(driver);
            singleton = new DataSource();
        } catch (SQLException sqle) {
            System.err.println(sqle);
        }
    }

    private static DataSource singleton;
   
    public static DataSource getInstance() {
        return singleton;
    }
    
    private DataSource() {}

    // per utilizzare Access
    /*
    private static String databaseURI = "jdbc:odbc:automobili";
    private static String userName = "";
    private static String password = "";
     */
    // per utilizzare PostgreSQL
    //private static String databaseURI = "jdbc:postgresql://192.168.153.128/automobili";
    private final String databaseURI = "jdbc:postgresql:acibase";
    private final String userName = "pguser";
    private final String password = "pguser";

    public Connection getConnection() throws DAOException {
        Connection connection = null;
        try {
            connection = DriverManager.getConnection(databaseURI, userName, password);
        } catch (SQLException sqle) {
            close(connection);
            throw new DAOException("getConnection: " + sqle);
        } 
        return connection;
    }

    public void close(Connection connection) {
        try {
            if (connection != null) {
                connection.close();
            }
        } catch (SQLException sqle) {
            System.err.println(sqle);
        }
    }

    public void close(Statement statement) {
        try {
            if (statement != null) {
                statement.close();
            }
        } catch (SQLException sqle) {
            System.err.println(sqle);
        }
    }

    public void close(ResultSet resultSet) {
        try {
            if (resultSet != null) {
                resultSet.close();
            }
        } catch (SQLException sqle) {
            System.err.println(sqle);
        }
    }

}
